opal/class/opal_hash_table.h File Reference.TH "opal/class/opal_hash_table.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
opal/class/opal_hash_table.h \- A hash table that may be indexed with either fixed length (e.g. 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'include/types.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br

.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef opal_hash_table_t \fBopal_hash_table_t\fP"
.br
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_init\fP (opal_hash_table_t *ht, size_t table_size)"
.br
.RI "\fIInitializes the table size, must be called before using the table. \fP"
.ti -1c
.RI "static size_t \fBopal_hash_table_get_size\fP (opal_hash_table_t *ht)"
.br
.RI "\fIReturns the number of elements currently stored in the table. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_remove_all\fP (opal_hash_table_t *ht)"
.br
.RI "\fIRemove all elements from the table. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_value_uint32\fP (opal_hash_table_t *table, uint32_t key, void **ptr)"
.br
.RI "\fIRetrieve value via uint32_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_set_value_uint32\fP (opal_hash_table_t *table, uint32_t key, void *value)"
.br
.RI "\fISet value based on uint32_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_remove_value_uint32\fP (opal_hash_table_t *table, uint32_t key)"
.br
.RI "\fIRemove value based on uint32_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_value_uint64\fP (opal_hash_table_t *table, uint64_t key, void **ptr)"
.br
.RI "\fIRetrieve value via uint64_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_set_value_uint64\fP (opal_hash_table_t *table, uint64_t key, void *value)"
.br
.RI "\fISet value based on uint64_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_remove_value_uint64\fP (opal_hash_table_t *table, uint64_t key)"
.br
.RI "\fIRemove value based on uint64_t key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_value_ptr\fP (opal_hash_table_t *table, const void *key, size_t keylen, void **ptr)"
.br
.RI "\fIRetrieve value via arbitrary length binary key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_set_value_ptr\fP (opal_hash_table_t *table, const void *key, size_t keylen, void *value)"
.br
.RI "\fISet value based on arbitrary length binary key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_remove_value_ptr\fP (opal_hash_table_t *table, const void *key, size_t keylen)"
.br
.RI "\fIRemove value based on arbitrary length binary key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_first_key_uint32\fP (opal_hash_table_t *table, uint32_t *key, void **value, void **node)"
.br
.RI "\fIGet the first 32 bit key from the hash table, which can be used later to get the next key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_next_key_uint32\fP (opal_hash_table_t *table, uint32_t *key, void **value, void *in_node, void **out_node)"
.br
.RI "\fIGet the next 32 bit key from the hash table, knowing the current key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_first_key_uint64\fP (opal_hash_table_t *table, uint64_t *key, void **value, void **node)"
.br
.RI "\fIGet the first 64 key from the hash table, which can be used later to get the next key. \fP"
.ti -1c
.RI "OMPI_DECLSPEC int \fBopal_hash_table_get_next_key_uint64\fP (opal_hash_table_t *table, uint64_t *key, void **value, void *in_node, void **out_node)"
.br
.RI "\fIGet the next 64 bit key from the hash table, knowing the current key. \fP"
.in -1c
.SS "Variables"

.in +1c
.ti -1c
.RI "OMPI_DECLSPEC \fBopal_class_t\fP \fBopal_hash_table_t_class\fP"
.br
.in -1c
.SH "Detailed Description"
.PP 
A hash table that may be indexed with either fixed length (e.g. 

uint32_t/uint64_t) or arbitrary size binary key values. However, only one key type may be used in a given table concurrently.
.SH "Function Documentation"
.PP 
.SS "OMPI_DECLSPEC int opal_hash_table_get_first_key_uint32 (opal_hash_table_t * table, uint32_t * key, void ** value, void ** node)"
.PP
Get the first 32 bit key from the hash table, which can be used later to get the next key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The hash table pointer (IN) 
.br
\fIkey\fP The first key (OUT) 
.br
\fIvalue\fP The value corresponding to this key (OUT) 
.br
\fInode\fP The pointer to the hash table internal node which stores the key-value pair (this is required for subsequent calls to get_next_key) (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_first_key_uint64 (opal_hash_table_t * table, uint64_t * key, void ** value, void ** node)"
.PP
Get the first 64 key from the hash table, which can be used later to get the next key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The hash table pointer (IN) 
.br
\fIkey\fP The first key (OUT) 
.br
\fIvalue\fP The value corresponding to this key (OUT) 
.br
\fInode\fP The pointer to the hash table internal node which stores the key-value pair (this is required for subsequent calls to get_next_key) (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_next_key_uint32 (opal_hash_table_t * table, uint32_t * key, void ** value, void * in_node, void ** out_node)"
.PP
Get the next 32 bit key from the hash table, knowing the current key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The hash table pointer (IN) 
.br
\fIkey\fP The key (OUT) 
.br
\fIvalue\fP The value corresponding to this key (OUT) 
.br
\fIin_node\fP The node pointer from previous call to either get_first or get_next (IN) 
.br
\fIout_node\fP The pointer to the hash table internal node which stores the key-value pair (this is required for subsequent calls to get_next_key) (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_next_key_uint64 (opal_hash_table_t * table, uint64_t * key, void ** value, void * in_node, void ** out_node)"
.PP
Get the next 64 bit key from the hash table, knowing the current key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The hash table pointer (IN) 
.br
\fIkey\fP The key (OUT) 
.br
\fIvalue\fP The value corresponding to this key (OUT) 
.br
\fIin_node\fP The node pointer from previous call to either get_first or get_next (IN) 
.br
\fIout_node\fP The pointer to the hash table internal node which stores the key-value pair (this is required for subsequent calls to get_next_key) (OUT) 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code 
.RE
.PP

.SS "static size_t opal_hash_table_get_size (opal_hash_table_t * ht)\fC [inline, static]\fP"
.PP
Returns the number of elements currently stored in the table. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
The number of elements in the table. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_value_ptr (opal_hash_table_t * table, const void * key, size_t keylen, void ** ptr)"
.PP
Retrieve value via arbitrary length binary key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIptr\fP The value associated with the key 
.RE
.PP
\fBReturns:\fP
.RS 4
integer return code:
.IP "\(bu" 2
OMPI_SUCCESS if key was found
.IP "\(bu" 2
OMPI_ERR_NOT_FOUND if key was not found
.IP "\(bu" 2
OMPI_ERROR other error 
.PP
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_value_uint32 (opal_hash_table_t * table, uint32_t key, void ** ptr)"
.PP
Retrieve value via uint32_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIptr\fP The value associated with the key 
.RE
.PP
\fBReturns:\fP
.RS 4
integer return code:
.IP "\(bu" 2
OMPI_SUCCESS if key was found
.IP "\(bu" 2
OMPI_ERR_NOT_FOUND if key was not found
.IP "\(bu" 2
OMPI_ERROR other error 
.PP
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_get_value_uint64 (opal_hash_table_t * table, uint64_t key, void ** ptr)"
.PP
Retrieve value via uint64_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIptr\fP The value associated with the key 
.RE
.PP
\fBReturns:\fP
.RS 4
integer return code:
.IP "\(bu" 2
OMPI_SUCCESS if key was found
.IP "\(bu" 2
OMPI_ERR_NOT_FOUND if key was not found
.IP "\(bu" 2
OMPI_ERROR other error 
.PP
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_init (opal_hash_table_t * ht, size_t table_size)"
.PP
Initializes the table size, must be called before using the table. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIsize\fP The size of the table, which will be rounded up (if required) to the next highest power of two (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_remove_all (opal_hash_table_t * ht)"
.PP
Remove all elements from the table. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_remove_value_ptr (opal_hash_table_t * table, const void * key, size_t keylen)"
.PP
Remove value based on arbitrary length binary key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_remove_value_uint32 (opal_hash_table_t * table, uint32_t key)"
.PP
Remove value based on uint32_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_remove_value_uint64 (opal_hash_table_t * table, uint64_t key)"
.PP
Remove value based on uint64_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_set_value_ptr (opal_hash_table_t * table, const void * key, size_t keylen, void * value)"
.PP
Set value based on arbitrary length binary key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIvalue\fP The value to be associated with the key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_set_value_uint32 (opal_hash_table_t * table, uint32_t key, void * value)"
.PP
Set value based on uint32_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIvalue\fP The value to be associated with the key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SS "OMPI_DECLSPEC int opal_hash_table_set_value_uint64 (opal_hash_table_t * table, uint64_t key, void * value)"
.PP
Set value based on uint64_t key. 
.PP
\fBParameters:\fP
.RS 4
\fItable\fP The input hash table (IN). 
.br
\fIkey\fP The input key (IN). 
.br
\fIvalue\fP The value to be associated with the key (IN). 
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI return code. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
